<?php
/**
 *
 * This file implements the Markdown plugin for b2evolution.
 *
 * b2evolution - {@link http://b2evolution.net/}
 * Released under GNU GPL License - {@link http://b2evolution.net/about/license.html}
 * @copyright (c)2003-2004 by Francois PLANQUE - b2evolution - {@link http://fplanque.net/}
 * @copyright (c)2004 by John Gruber - Markdown - {@link http://daringfireball.net/projects/markdown/}
 * @copyright (c)2007 by Michel Fortin - PHP Markdown - {@link http://www.michelf.com/projects/php-markdown/}
 * @copyright (c)2007 by Joseph Lorenzo Hall - b2evo renderer - {@link http://pobox.com/~joehall/b2evo_markdown/}
 *
 * @package plugins
 *
 * @author Joseph Lorenzo Hall
 *
 */
if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );


/**
 * Includes:
 */

//this provides PHP Markdown 1.0.1m with lines the end of the
//doAnchors function uncommented to support implicit links.

include_once "markdown.php";

/**
 * Markdown Plugin
 *
 * Markdown is a light syntax meant to be easy to read and also easy
 * to parse into HTML.  This plugin uses the markdown.php
 * implementation from Michel Fortin of John Gruber's Markdown
 * language.
 * 
 *
 * @package plugins
 */
class markdown_plugin extends Plugin
{
	/**
	 * Variables below MUST be overriden by plugin implementations,
	 * either in the subclass declaration or in the subclass constructor.
	 */
	var $name = 'Markdown';
	/**
	 * Code, if this is a renderer or pingback plugin.
	 */
	var $code = 'b2evMrkdwn';
	var $priority = 59; // 59 is one lower than AutoLinks
	var $version = '0.3';
	var $author = 'http://josephhall.org/nqb2/';
	var $help_url = 'http://josephhall.org/b2evo_markdown/';
	var $group = 'rendering';
	var $apply_rendering = 'opt-out';


	/**
	 * Init
	 *
	 * This gets called after a plugin has been registered/instantiated.
	 */
	function PluginInit( & $params )
	{
		$this->short_desc = $this->T_('Parse Markdown syntax into HTML');
		$this->long_desc = $this->T_('This plugin implements John Gruber\'s Markdown language syntax.  It takes markdown and converts it into HTML via Michel Fortin\'s markdown.php.');
	}


	/**
	 * Define settings that the plugin uses/provides.
	 */
	function GetDefaultSettings()
	{
		return array(
			);
	}


	/**
	 * Define user settings that the plugin uses/provides.
	 */
	function GetDefaultUserSettings()
	{
		return array(
			);
	}

	// Add the methods to hook into here...
	// See http://doc.b2evolution.net/stable/plugins/Plugin.html
	function RenderItemAsHtml( & $params )
	{
		$content = & $params['data'];
		$content = Markdown( $content );
		return true;
	}


}
?>
